/* poly04.c                        freeware                    xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include <stdio.h>
#include <math.h>
#include "mydefine.h"
#include "mydata.h"
#include "myprint.h"     /* printm printrow printcol                          */
#include "mycopy.h"      /*  copym  copyrow  copycol                          */
#include "myspecm.h"     /* identity, zero matrix                             */
#include "myfmint.h"     /* rownmini divide a row by a integer if possible    */
#include "myelemrowop.h" /* Elementary row operations. swaprow multrow addrow */
#include "myfmop.h"      /* add, multiply two matrices. transpose             */
#include "myfpivot.h"    /* pivotntzero pivotwork                             */
#include "myfdet.h"      /* det, minor, cofactor, mcofactor, adjoint          */
#include "mygauss.h"     /* gauss gaussjordan                                 */
#include "myid.h"        /* gaussjordan(), inverse() with the identity matrix */
#include "mypoly.h"      /* mofpoly, resultis, calculate_y                    */

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 main()
{
fraction f;
double pbpxy[3][2*TWOCOL]=
{
  1,1,    -9,1,
  2,1,     8,1,
  3,1,    -8,1,
};
matrix mpxy={3,2*TWOCOL,&pbpxy[0][0]};

double pblock[3][4*TWOCOL];
matrix m={3,4*TWOCOL,&pblock[0][0]};

/*-------------------------------- PROGRAM ---------------------------------- */
  printf("\n");
  printf(" Find the coefficients a, b, c  of the curve   \n\n");
  printf("      y =  ax**2 + bx + c           (x**0 = 1) \n\n");
  printf(" that passes through the points.               \n\n");

  printf("     x            y \n");
  printmF(&mpxy);

  printf("\n");
  printf(" Using the given points, we obtain this matrix\n\n");
  printf("     x**2         x**1         ");
  printf("x**0         y\n");
  mofpoly(&mpxy,&m);
  printmF(      &m);
  getchar();

  printf("The Gauss Jordan process will reduce this matrix to : \n");
  gaussjordanF(&m);
  printmF(&m);

  printf("\n");
  printf(" The coefficients a, b, c of the curve are :  \n\n");
  resultis(&m);
  getchar();

   printf("     x            y   The given point.\n");
   printmF(&mpxy);
   printf("\n");

  printf("Verify the result : \n\n");
  f.numer = 1; f.denom = 1; calculate_y(&m,f);
  f.numer = 2; f.denom = 1; calculate_y(&m,f);
  f.numer = 3; f.denom = 1; calculate_y(&m,f);

  printf("\n Press a key to continue");
  getchar();
}



